#!/usr/bin/perl
############################################
# Input structure preprocessing    
############################################

$strname=$ARGV[0];
$bindir=$ARGV[1];
%ts=(
 'GLY'=>'G',
 'ALA'=>'A',
 'VAL'=>'V',
 'LEU'=>'L',
 'ILE'=>'I',
 'SER'=>'S',
 'THR'=>'T',
 'CYS'=>'C',
 'MET'=>'M',
 'PRO'=>'P',
 'ASP'=>'D',
 'ASN'=>'N',
 'GLU'=>'E',
 'GLN'=>'Q',
 'LYS'=>'K',
 'ARG'=>'R',
 'HIS'=>'H',
 'PHE'=>'F',
 'TYR'=>'Y',
 'TRP'=>'W',
    );

&checkallatom(); #check input structure. if not all-atom, rebuid by PULCHRA.

open(PDB,$strname) or die "Cannot open $strname: $!\n";
open(SEQOUT,"> seq.fasta") or die "Cannot make seq.fasta: $!\n";
open(CAOUT,"> CA") or die "Cannot make CA: $!\n";
print SEQOUT ">protein\n";
@oupcnt=();
%alterp=();
%cacheck=();
$serial=1;
$resSeq=1;
$n=0;
$lrq=1;
while($line=<PDB>){
  if($line=~/^ATOM/){
    $check=substr($line,22,4).substr($line,12,4);
    if(!exists $alterp{$check}){
      substr($line,22,4)=~/(\S+)/;
      $crq=$1;
      $resSeq++ if($crq!=$lrq && $n!=0 && exists $cacheck{$resSeq});
      if(substr($line,13,2) eq 'CA'||substr($line,12,2) eq 'CA'||substr($line,14,2) eq 'CA'){
        if(!exists $ts{substr($line,17,3)}){
          print "Residue name \"substr($line,17,3)\" cannot be recognized, quit!\n";
          exit();
        }
        print SEQOUT "$ts{substr($line,17,3)}";
        substr($line,6,5)=sprintf "%5d", $resSeq;
        substr($line,22,4)=sprintf "%4d", $resSeq;
        print CAOUT $line;
        print SEQOUT "\n" if(int($resSeq/60)*60==$resSeq);
        $cacheck{$resSeq}="exist";
      }
      $lrq=$crq;
      substr($line,6,5)=sprintf "%5d", $serial++;
      substr($line,22,4)=sprintf "%4d", $resSeq;
      $oupcnt[$n++]=$line;
      $alterp{$check}="Done";
    }
  }
  last if($line=~/^TER/);
}
print CAOUT "TER ";
close(PDB);
close(CAOUT);
close(SEQOUT);

$resSeq-- if !exists $cacheck{$resSeq};
open(RMSI, "> rmsinp") or die "Cannot make rmsinp: $!\n";
print RMSI "1  $resSeq\n$resSeq\nprotein\n";
close(RMSI);


if($resSeq!=$lrq){
  open(PDBOUT, "> $strname") or die "Cannot make $strname: $!\n";
  foreach (@oupcnt){
    print PDBOUT $_;
  }
}
print PDBOUT "TER ";
close(PDBOUT);

sub checkallatom{
  %alterp=();
  $nca=0;
  $nal=0;
  open(PDB,$strname) or die "Cannot open $strname: $!\n";
  while($line=<PDB>){
    if($line=~/^ATOM/){
      $check=substr($line,22,4).substr($line,12,4);
      if(!exists $alterp{$check}){
        $nal++;
        $nca++ if(substr($line,13,2) eq 'CA'||substr($line,12,2) eq 'CA'||substr($line,14,2) eq 'CA');
      }
    }
  }
  if($nal/$nca<4){
    `$bindir/pulchra304 -c $strname`;
    $outpdb=substr($strname,0,rindex($strname,".")).".rebuilt.pdb";
    rename("$outpdb","$strname");
  }
}