#!/usr/bin/perl
#########################################
# Generate second structure restraints  #
#########################################

$librarydir=$ARGV[0];
$bindir=$ARGV[1];
$recorddir=$ARGV[2];
$init=$ARGV[3];
$strname=$ARGV[4];

open(INI,"$recorddir/$init") or die "Can't open $recorddir/$init $!\n";
if(<INI>=~/(\S+)\s+\S+\s+\S+/){
  $ntmp=$1; #number of templates
}

open(CALPHA,"$recorddir/CA") or die "Cannot open $recorddir/CA $!\n";
$n=0;
@sequ=();
%alterp=();
while(<CALPHA>){
  if(substr($_,13,2) eq 'CA'||substr($_,12,2) eq 'CA'||substr($_,14,2) eq 'CA'){
    $check=substr($_,22,4).substr($_,12,4);
    if(!exists $alterp{$check}){
      $n++;
      $sequ[$n]=substr($_,17,3);
      $alterp{$check}="Done";
    }
  }elsif ($_=~/^TER/ && $n>0){
    last;
  }
}
$Lch=$n;
close(CALPHA);

open(OUT1,"> $recorddir/seq.stru") or die "Can't make $recorddir/seq.stru $!\n";
open(OUT2,"> $recorddir/ssdis.dat") or die "Can't make $recorddir/ssdis.dat $!\n";

for($str_id=1;$str_id<=$ntmp;$str_id++){
  %sstr=();
  %nresn=();
  %nrest=();
  %xC=();
  %yC=();
  %zC=();
  %ssdis0=();
  %ssdis=();
  @results=();
  $NHB0=0;
  $NHB=0;
  if($str_id>1){
    $flag=0;
    while($line=<INI>){
      if($line=~/(\d+)\s+\S+\s+(\d+)\s+(\S+)\s+TMalign/){
        $nali=$1;
        $id=$2;
        $tmpl=$3;
        next unless $id==$str_id;
        @results=`$bindir/stride $librarydir/$tmpl.pdb -h`;
        if(@results<=1){#avoid stride bug
          $result=`cat $librarydir/$tmpl.pdb`;
          $result=~s/^HEADER//mg;
          open(TMPL,"> $tmpl.pdb");
          print TMPL $result;
          close(TMPL);
          @results=`$bindir/stride $tmpl.pdb -h`;
          `rm $tmpl.pdb`;
        }
        foreach $result (@results){
          if($result=~/ASG\s+\S+ \S+\s+(\d+)\s+\d+\s+(\S+)/){
            $sstr{$1}=&sectrans($2);
          }
          if($result=~/^ACC\s+\S+\s+\S+\s+(\d+)\s+\d+ ->\s+\S+\s+\S+\s+(\d+)/){
            $ssdis0{$2}{$1}=$NHB0++;
          }
          if($result=~/^DNR\s+\S+\s+\S+\s+(\d+)\s+\d+ ->\s+\S+\s+\S+\s+(\d+)/){
            $ssdis0{$1}{$2}=$NHB0++;
          }
        }
        @nsec= sort {$a <=> $b} keys %sstr;
        &smooth();
        $m=0;
        $flag=1;
      }
      if($flag==1){
        if($line=~/^ATOM/){
          $nn=substr($line,22,4);
          $nn=~s/\s+//mg;
          $tn=substr($line,55,4);
          $tn=~s/\s+//mg;
          $nresn{$tn}=$nn;
          $nrest{$nn}=$tn;
          $m++;
        }
        if($m==$nali){
          printf OUT1 "$str_id\n";
          for($i=1;$i<=$Lch;$i++){
            if(exists $nrest{$i}){
              printf OUT1 "%5d%6s%5d\n",$i,$sequ[$i],$sstr{$nrest{$i}};
            }else{
              printf OUT1 "%5d%6s%5d\n",$i,$sequ[$i],1;
            }
          }
          $nh=0;
          @pair_i= keys %ssdis0;
          foreach $i (@pair_i){
            @pair_j= keys %{$ssdis0{$i}};
            foreach $j (@pair_j){
              if(exists $nresn{$i} && exists $nresn{$j}){
                $nh++;
                if(!exists $ssdis{$nresn{$j}}{$nresn{$i}}){
                  $ssdis{$nresn{$i}}{$nresn{$j}}=$NHB++;
                }
              }
            }
          }
          print OUT2 "$NHB  $str_id  $tmpl\n";
          @pair_i= sort {$a <=> $b} keys %ssdis;
          foreach $i (@pair_i){
            @pair_j= sort {$a <=> $b} keys %{$ssdis{$i}};
            foreach $j (@pair_j){
              printf OUT2 "%6d%6d\n",$i,$j;
            }
          }
          $flag==0;
          last;
        }
      }
    }
  }else{
    if(-s "$recorddir/$strname"){
      $ntv="$recorddir/$strname";
    }elsif(-s "$recorddir/CA"){
      print "Warining: No $strname\n";
      `$bindir/pulchra304 $recorddir/CA`;
      $ntv="$recorddir/CA.rebuilt.pdb";
    }else{
      print "No native or CA file\n";
      exit();
    }
    @results=`$bindir/stride $ntv -h`;
    foreach $result (@results){
      if($result=~/ASG\s+(\S+) \S+\s+(\d+)\s+\d+\s+(\S+)/){
        $snam{$2}=$1;
        $sstr{$2}=&sectrans($3);
      }
      if($result=~/^ACC\s+\S+\s+\S+\s+(\d+)\s+\d+ ->\s+\S+\s+\S+\s+(\d+)/){
        $NHB++ if !exists $ssdis{$1}{$2} && !exists $ssdis{$2}{$1};
        $ssdis{$2}{$1}=$NHB0++;
      }
      if($result=~/^DNR\s+\S+\s+\S+\s+(\d+)\s+\d+ ->\s+\S+\s+\S+\s+(\d+)/){
        $NHB++ if !exists $ssdis{$2}{$1} && !exists $ssdis{$1}{$2};
        $ssdis{$1}{$2}=$NHB0++;
      }
    }
    @nsec= sort {$a <=> $b} keys %sstr;
    &smooth();
    #open(SEQS,"> $recorddir/seq.stride") or die "Can't make $recorddir/seq.stride $!\n";
    printf OUT1 "$str_id\n";
    for($i=1;$i<=$Lch;$i++){
      if(exists $snam{$i} && $snam{$i} eq $sequ[$i]){
        printf OUT1 "%5d%6s%5d\n",$i,$sequ[$i],$sstr{$i};
      }elsif($i>1){
        printf OUT1 "%5d%6s%5d\n",$i,$sequ[$i],$sstr{$i-1};
      }else{
        printf OUT1 "%5d%6s%5d\n",$i,$sequ[$i],1;
      }
      #printf SEQS "%5d%6s%5d    9\n",$ns,$snam{$ns},$sstr{$ns};
    }
    #close(SEQS);
    $nh=0;
    %sschk=();
    print OUT2 "$NHB  $str_id  native\n";
    @pair_i= sort {$a <=> $b} keys %ssdis;
    foreach $i (@pair_i){
      @pair_j= sort {$a <=> $b} keys %{$ssdis{$i}};
      foreach $j (@pair_j){
        $nh++;
        if(!exists $sschk{$j}{$i}){
          printf OUT2 "%6d%6d\n",$i,$j;
        }
        $sschk{$i}{$j}="done";
      }
    }
  }
}
close(OUT1);
close(OUT2);

sub sectrans{
  my $sec;
  if($_[0] eq "H"||$_[0] eq "G" ||$_[0] eq "I"){
    $sec=2;
  }
  elsif($_[0] eq "B" ||$_[0] eq "b" ||$_[0] eq "E"){
    $sec=4;
  }
  else{
    $sec=1;
  }
  return $sec;
}

sub smooth{
  foreach $i (@nsec){
    if($sstr{$i} eq "2"){
      if($sstr{$i-1} ne "2"){
        if($sstr{$i-2} ne "2"){
          if($sstr{$i+1} ne "2"){
            if($sstr{$i+2} ne "2"){
              $sstr{$i}=1;
            }
          }
        }
      }
    }
  }
#  foreach $i (@nsec){
#    if($sstr{$i+0} ne "2"){
#      if($sstr{$i+1} ne "2"){
#        if($sstr{$i+2} eq "2"){
#          if($sstr{$i+3} eq "2"){
#            if($sstr{$i+4} ne "2"){
#              if($sstr{$i+5} ne "2"){
#                $sstr{$i+2}=1;
#                $sstr{$i+3}=1;
#              }
#            }
#          }
#        }
#      }
#    }
#  }
  $sstr{$nsec[0]}=$sstr{$nsec[1]} if($sstr{$nsec[0]} eq "1" && $sstr{$nsec[1]} ne "1");
  $sstr{$nsec[-1]}=$sstr{$nsec[-2]} if($sstr{$nsec[-1]} eq "1" && $sstr{$nsec[-2]} ne "1");
}